﻿;form2

Declare F2EnterForm()
Declare F2CancelEdit()
Declare F2AddRecord()
Declare F2SaveRecord()
Declare F2DeleteRecord()
Declare F2FillForm()
Declare F2MoveTo(Target)
Declare F2SetMode(Mode)
Declare F2StoreForm()
Declare F2RestoreForm()

;=== begin: Form Designer code

Global F2Form, F2ToolBar, F2StatusBar

Global F2Frame_0, F2lblRecID, F2lblContactName, F2lblPhone, F2lblEmail, F2lblWebURL, F2txtRecID, F2txtContactName, F2txtPhone, F2txtEmail, F2txtWebURL

Global Img_F2Form_0, Img_F2Form_1, Img_F2Form_2, Img_F2Form_3, Img_F2Form_4, Img_F2Form_5, Img_F2Form_6, Img_F2Form_7

Enumeration FormMenu
  #F2barFirstRec
  #F2barPrevRec
  #F2barNextRec
  #F2barLastRec
  #F2barAddRec
  #F2barDeleteRec
  #F2barSaveRec
  #F2barCancel
EndEnumeration

Img_F2Form_0 = LoadImage(#PB_Any,"firstrec.ico")
Img_F2Form_1 = LoadImage(#PB_Any,"prevrec.ico")
Img_F2Form_2 = LoadImage(#PB_Any,"nextrec.ico")
Img_F2Form_3 = LoadImage(#PB_Any,"lastrec.ico")
Img_F2Form_4 = LoadImage(#PB_Any,"add.ico")
Img_F2Form_5 = LoadImage(#PB_Any,"delete.ico")
Img_F2Form_6 = LoadImage(#PB_Any,"save.ico")
Img_F2Form_7 = LoadImage(#PB_Any,"cancel.ico")

Procedure OpenF2Form(x = 0, y = 0, width = 380, height = 280)
  F2Form = OpenWindow(#PB_Any, x, y, width, height, "Contact Manager v0.0 Form2", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
;  CreateToolBar(0, WindowID(F2Form))
  F2ToolBar = CreateToolBar(#PB_Any, WindowID(F2Form), #PB_ToolBar_Large)
  ToolBarImageButton(#F2barFirstRec,ImageID(Img_F2Form_0))
  ToolBarImageButton(#F2barPrevRec,ImageID(Img_F2Form_1))
  ToolBarImageButton(#F2barNextRec,ImageID(Img_F2Form_2))
  ToolBarImageButton(#F2barLastRec,ImageID(Img_F2Form_3))
  ToolBarSeparator()
  ToolBarImageButton(#F2barAddRec,ImageID(Img_F2Form_4))
  ToolBarImageButton(#F2barDeleteRec,ImageID(Img_F2Form_5))
  ToolBarImageButton(#F2barSaveRec,ImageID(Img_F2Form_6))
  ToolBarImageButton(#F2barCancel,ImageID(Img_F2Form_7))
;  CreateStatusBar(0, WindowID(F2Form))
  F2StatusBar = CreateStatusBar(#PB_Any, WindowID(F2Form))
  AddStatusBarField(#PB_Ignore)
; change all ToolBarHeight(2) to ToolBarHeight(F2ToolBar)
  F2Frame_0 = FrameGadget(#PB_Any, 20, ToolBarHeight(F2ToolBar) + 10, 340, 200, "Contact Record")
  F2lblRecID = TextGadget(#PB_Any, 36, ToolBarHeight(F2ToolBar) + 43, 90, 20, "Rec ID:", #PB_Text_Right)
  F2lblContactName = TextGadget(#PB_Any, 36, ToolBarHeight(F2ToolBar) + 73, 90, 20, "Contact Name:", #PB_Text_Right)
  F2lblPhone = TextGadget(#PB_Any, 36, ToolBarHeight(F2ToolBar) + 103, 90, 20, "Phone:", #PB_Text_Right)
  F2lblEmail = TextGadget(#PB_Any, 36, ToolBarHeight(F2ToolBar) + 133, 90, 20, "Email:", #PB_Text_Right)
  F2lblWebURL = TextGadget(#PB_Any, 36, ToolBarHeight(F2ToolBar) + 163, 90, 20, "Web URL:", #PB_Text_Right)
  F2txtRecID = StringGadget(#PB_Any, 130, ToolBarHeight(F2ToolBar) + 40, 30, 20, "")
  DisableGadget(F2txtRecID, 1)
  F2txtContactName = StringGadget(#PB_Any, 130, ToolBarHeight(F2ToolBar) + 70, 200, 20, "")
  F2txtPhone = StringGadget(#PB_Any, 130, ToolBarHeight(F2ToolBar) + 100, 120, 20, "")
  F2txtEmail = StringGadget(#PB_Any, 130, ToolBarHeight(F2ToolBar) + 130, 160, 20, "")
  F2txtWebURL = StringGadget(#PB_Any, 130, ToolBarHeight(F2ToolBar) + 160, 200, 20, "")
EndProcedure

;=== end: Form Designer code

Enumeration
  #F2ModeUndefined = -1
  #F2ModeDataEntry
  #F2ModeNavigation
EndEnumeration

Enumeration
  #F2NavFirst
  #F2NavPrev
  #F2NavNext
  #F2NavLast
EndEnumeration

Define F2isAdding.b
Define F2CurrentMode.b
Define F2ContactsBackup.ContactsStructure

Procedure F2HandleForm()
  Shared F2CurrentMode
  F2CurrentMode = #F2ModeUndefined
  Shared F2isAdding
  F2isAdding = #False
  OpenF2Form()
  AddMapElement(AppData\Forms(), Str(F2Form))
  F2StoreForm()
  SetActiveWindow(F2Form)
  If ContactsRecord\ID = 0
    F2AddRecord()
  Else
    F2FillForm()
  EndIf
EndProcedure

Procedure F2EnterForm()
  Shared F2CurrentMode
  Shared F2ContactsBackup
  If F2CurrentMode = #F2ModeNavigation
    F2ContactsBackup = ContactsRecord
    F2SetMode(#F2ModeDataEntry)
  EndIf
EndProcedure  

Procedure F2AddRecord()
  Shared F2isAdding
  Shared F2ContactsBackup
  F2ContactsBackup = ContactsRecord
  ClearStructure(@ContactsRecord, ContactsStructure)
  F2FillForm()
  F2SetMode(#F2ModeDataEntry)
  StatusBarText(F2StatusBar, 0, "Enter new contact record")
  SetActiveGadget(F2txtContactName)
  F2isAdding = #True
EndProcedure

Procedure F2CancelEdit()
  Shared F2isAdding
  Shared F2ContactsBackup
  ContactsRecord = F2ContactsBackup
  F2FillForm()
  F2isAdding = #False
  If ListSize(ContactsList()) = 0
    CloseWindow(F2Form)
  EndIf
EndProcedure

Procedure F2SaveRecord()
  ContactsRecord\FullName = GetGadgetText(F2txtContactName)
  ContactsRecord\Phone = GetGadgetText(F2txtPhone)
  ContactsRecord\Email = GetGadgetText(F2txtEmail)
  ContactsRecord\WebURL = GetGadgetText(F2txtWebURL)
  Shared F2isAdding
  If F2isAdding = #True
    StatusBarText(F2StatusBar, 0, "Inserting contact record")
    InsertContacts()
    If ContactsRecord\ID > 0
      F2isAdding = #False
      F2FillForm()
    Else
      SetActiveGadget(F2txtContactName)
      F2SetMode(#F2ModeDataEntry)
    EndIf
  Else
    StatusBarText(F2StatusBar, 0, "Updating contact record")
    UpdateContacts()
    If ContactsRecord\ID > 0
      F2FillForm()
    Else
      SetActiveGadget(F2txtContactName)
      F2SetMode(#F2ModeDataEntry)
    EndIf
  EndIf
EndProcedure

Procedure F2DeleteRecord()
  If MessageRequester("Caution", "Do you wish to delete this record?", #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
    DeleteContacts()
    If ListSize(ContactsList()) = 0
      F2addRecord()
    Else
      F2FillForm()
    EndIf
  EndIf
EndProcedure

Procedure F2FillForm()
  F2SetMode(#F2ModeNavigation)
  SetGadgetText(F2txtRecID, Right("0000" + Trim(Str(ContactsRecord\ID)), 4))
  SetGadgetText(F2txtContactName, ContactsRecord\FullName)
  SetGadgetText(F2txtPhone, ContactsRecord\Phone)
  SetGadgetText(F2txtEmail, ContactsRecord\Email)
  SetGadgetText(F2txtWebURL, ContactsRecord\WebURL)
  SetActiveGadget(#PB_Any)
  StatusBarText(F2StatusBar, 0, "Ready")
EndProcedure

Procedure F2MoveTo(Target)
  Select Target
    Case #F2NavFirst
      FirstElement(ContactsList())
    Case #F2NavPrev
      If PreviousElement(ContactsList()) = 0
        LastElement(ContactsList())
      EndIf
    Case #F2NavNext
      If NextElement(ContactsList()) = 0
        FirstElement(ContactsList())
      EndIf
    Case #F2NavLast
      LastElement(ContactsList())
  EndSelect
  List2Record()
  F2FillForm()
EndProcedure

Procedure F2SetMode(Mode)
  Shared F2CurrentMode.b
  If Mode <> F2CurrentMode
    Select Mode
      Case #F2ModeDataEntry
        DisableToolBarButton(F2ToolBar, #F2barFirstRec, #True)
        DisableToolBarButton(F2ToolBar, #F2barPrevRec, #True)
        DisableToolBarButton(F2ToolBar, #F2barNextRec, #True)
        DisableToolBarButton(F2ToolBar, #F2barLastRec, #True)
        DisableToolBarButton(F2ToolBar, #F2barAddRec, #True)
        DisableToolBarButton(F2ToolBar, #F2barDeleteRec, #True)
        DisableToolBarButton(F2ToolBar, #F2barSaveRec, #False)
        DisableToolBarButton(F2ToolBar, #F2barCancel, #False)
        RemoveKeyboardShortcut(F2Form, #PB_Shortcut_PageDown)
        RemoveKeyboardShortcut(F2Form, #PB_Shortcut_PageUp)
        RemoveKeyboardShortcut(F2Form, #PB_Shortcut_Insert)
        RemoveKeyboardShortcut(F2Form, #PB_Shortcut_Delete)
        AddKeyboardShortcut(F2Form, #PB_Shortcut_Control | #PB_Shortcut_S, #F2barSaveRec)
        AddKeyboardShortcut(F2Form, #PB_Shortcut_Escape, #F2barCancel)
        F2CurrentMode = #F2ModeDataEntry
      Case #F2ModeNavigation
        DisableToolBarButton(F2ToolBar, #F2barFirstRec, #False)
        DisableToolBarButton(F2ToolBar, #F2barPrevRec, #False)
        DisableToolBarButton(F2ToolBar, #F2barNextRec, #False)
        DisableToolBarButton(F2ToolBar, #F2barLastRec, #False)
        DisableToolBarButton(F2ToolBar, #F2barAddRec, #False)
        DisableToolBarButton(F2ToolBar, #F2barDeleteRec, #False)
        DisableToolBarButton(F2ToolBar, #F2barSaveRec, #True)
        DisableToolBarButton(F2ToolBar, #F2barCancel, #True)
        RemoveKeyboardShortcut(F2Form, #PB_Shortcut_Control | #PB_Shortcut_S)
        RemoveKeyboardShortcut(F2Form, #PB_Shortcut_Escape)
        AddKeyboardShortcut(F2Form, #PB_Shortcut_PageDown, #F2barNextRec)
        AddKeyboardShortcut(F2Form, #PB_Shortcut_PageUp, #F2barPrevRec)
        AddKeyboardShortcut(F2Form, #PB_Shortcut_Insert, #F2barAddRec)
        AddKeyboardShortcut(F2Form, #PB_Shortcut_Delete, #F2barDeleteRec)
        F2CurrentMode = #F2ModeNavigation
    EndSelect
  EndIf
EndProcedure

Procedure F2RestoreForm()
  ResetList(AppData\Forms()\Gadgets())
  NextElement (AppData\Forms()\Gadgets())
  F2ToolBar = AppData\forms()\Gadgets()
  NextElement (AppData\Forms()\Gadgets())
  F2StatusBar = AppData\forms()\Gadgets()
  NextElement (AppData\Forms()\Gadgets())
  F2Frame_0 = AppData\forms()\Gadgets()
  NextElement(AppData\Forms()\Gadgets())
  F2lblRecID = AppData\forms()\Gadgets()
  NextElement(AppData\Forms()\Gadgets())
  F2lblContactName = AppData\forms()\Gadgets()
  NextElement(AppData\Forms()\Gadgets())
  F2lblPhone = AppData\forms()\Gadgets()
  NextElement(AppData\Forms()\Gadgets())
  F2lblEmail = AppData\forms()\Gadgets()
  NextElement(AppData\Forms()\Gadgets())
  F2lblWebURL = AppData\forms()\Gadgets()
  NextElement(AppData\Forms()\Gadgets())
  F2txtRecID = AppData\forms()\Gadgets()
  NextElement(AppData\Forms()\Gadgets())
  F2txtContactName = AppData\forms()\Gadgets()
  NextElement(AppData\Forms()\Gadgets())
  F2txtPhone = AppData\forms()\Gadgets()
  NextElement(AppData\Forms()\Gadgets())
  F2txtEmail = AppData\forms()\Gadgets()
  NextElement(AppData\Forms()\Gadgets())
  F2txtWebURL = AppData\forms()\Gadgets()
EndProcedure

Procedure F2StoreForm()
  AppData\Forms()\Name = "form2"
  AddElement(AppData\Forms()\Gadgets())
  AppData\Forms()\Gadgets() = F2ToolBar
  AddElement(AppData\Forms()\Gadgets())
  AppData\Forms()\Gadgets() = F2StatusBar
  AddElement(AppData\Forms()\Gadgets())
  AppData\Forms()\Gadgets() = F2Frame_0
  AddElement(AppData\Forms()\Gadgets())
  AppData\Forms()\Gadgets() = F2lblRecID
  AddElement(AppData\Forms()\Gadgets())
  AppData\Forms()\Gadgets() = F2lblContactName
  AddElement(AppData\Forms()\Gadgets())
  AppData\Forms()\Gadgets() = F2lblPhone
  AddElement(AppData\Forms()\Gadgets())
  AppData\Forms()\Gadgets() = F2lblEmail
  AddElement(AppData\Forms()\Gadgets())
  AppData\Forms()\Gadgets() = F2lblWebURL
  AddElement(AppData\Forms()\Gadgets())
  AppData\Forms()\Gadgets() = F2txtRecID
  AddElement(AppData\Forms()\Gadgets())
  AppData\Forms()\Gadgets() = F2txtContactName
  AddElement(AppData\Forms()\Gadgets())
  AppData\Forms()\Gadgets() = F2txtPhone
  AddElement(AppData\Forms()\Gadgets())
  AppData\Forms()\Gadgets() = F2txtEmail
  AddElement(AppData\Forms()\Gadgets())
  AppData\Forms()\Gadgets() = F2txtWebURL
EndProcedure
